#Simply Mongo

[![Gem Version][GV img]][Gem Version]
[![Build Status][BS img]][Build Status]
[![Dependency Status][DS img]][Dependency Status]
<!-- [![Coverage Status][CS img]][Coverage Status] -->


This project uses an MIT-LICENSE.

Installing the **simply_mongo** gem sets up a Rails environment where the standard Mongo driver can be easily used.

## Intstallation

    $ gem install simply_mongo


After installing the gem run the Rails generator:  

    $ rails g simply_mongo:install

This creates the YAML file 'config/mongo.yml' that contains the database configuration parameters.

## Examples
A simple controller example of adding a document to a collection

      e = params[:enterprise]                    # extract the JSON document
      ec = SimplyMongo.db['CollectionName']      # get reference to collection
      e[:_id] = BSON::ObjectId.new
      ec.insert(e)                               # stuff document into collection

## Simple JSON Document

    "enterprise": {
        "city": "Bedrock", 
        "contacts": [
            {
                "email": [
                    {
                        "description": "Work Email", 
                        "email": "fflintstone@bedrock.com"
                    }
                ], 
                "first_name": "Fred", 
                "last_name": "Flintstone", 
                "phone": [
                    {
                        "description": "Home Phone", 
                        "number": "1-123-1234"
                    }
                ]
            }
        ], 
        "country": "US", 
        "description": "We dig and move rocks and gravel using the latest technologies", 
        "name": "Slate Rock and Gravel", 
        "phone": "1.123.1234", 
        "street": "123 Quarry Pit", 
        "web_site": "http://www.slaterockandgravel.com", 
        "zip": "12345"
    }


## Simple Rails Controller Example

    require 'simply_mongo'

    class EnterprisesController < ApplicationController

      def create
        e = params[:enterprise]
        ec = SimplyMongo.db['enterprises']
        id = BSON::ObjectId.new
        e[:_id] = id
        ec.insert(e)
        eid = ec.find_one({'_id' => id}, { :fields => [ '_id'] } )
        j = { :id => eid['_id'].to_s}
        render :text => j.to_json
      end

      def index
        ec = SimplyMongo.db['enterprises']
        c = ec.find()
        e = [ ]
        c.each { |ce| e.push(ce) }
        render :text => e.to_json
      end

      def show
        ec = SimplyMongo.db['enterprises']
        id = params['id']
        bid = BSON::ObjectId id
        one = ec.find_one({ '_id' => bid})
        if one.nil?
          render :text => { }.to_json
        else
          oid = one['_id']
          one['_id'] = oid.to_s
          render :text => one.to_json
        end
      end

      def update
        p = params.clone
        id = p.delete('id')
        bid = BSON::ObjectId id
        p['_id'] = bid
        ec = SimplyMongo.eb['enterprises']
        ec.update({'_id' => bid}, p)
        render :text => "{ 'code': 'success'}"
      end

      def destroy
        ec = SimplyMongo.db['enterprises']
        id = params['id']
        bid = BSON::ObjectId id
        ec.remove({ '_id' => bid})
        render :text => { :removed =>"removed"}
      end

    end
    
# Versioning
This library aims to adhere to [Semantic Versioning 2.0.0](http://semver.org/). Violations of this scheme should be reported as bugs. Specifically, if a minor or patch version is released that breaks backward compatibility, that version should be immediately yanked and/or a new version should be immediately released that restores compatibility. Breaking changes to the public API will only be introduced with new major versions. As a result of this policy, you can (and should) specify a dependency on this gem using the [Pessimistic Version Constraint](http://docs.rubygems.org/read/chapter/16#page74) with two digits of precision. 

For example:

        spec.add_dependency 'simply_mongo', '~> 1.0'
        

[Gem Version]: https://rubygems.org/gems/simply_mongo
[Build Status]: https://travis-ci.org/robdbirch/simply_mongo
[travis pull requests]: https://travis-ci.org/robdbirch/simply_mongo/pull_requests
[Dependency Status]: https://gemnasium.com/robdbirch/simply_mongo
[Coverage Status]: https://coveralls.io/r/robdbirch/simply_mongo

[GV img]: https://badge.fury.io/rb/simply_mongo.png
[BS img]: https://travis-ci.org/robdbirch/simply_mongo.png
[DS img]: https://gemnasium.com/robdbirch/simply_mongo.png
<!-- [CS img]: https://coveralls.io/repos/robdbirch/simply_mongo/badge.png?branch=master -->
